Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joone.engine.extenders
Class DeltaRuleExtender

    java.lang.Object
      org.joone.engine.extenders.LearnerExtender
          org.joone.engine.extenders.DeltaRuleExtender

Direct Known Subclasses:
  MomentumExtender, RpropExtender, SimulatedAnnealingExtender, WeightDecayExtender

    public abstract class DeltaRuleExtender

extends LearnerExtender

This abstract class describes the methods needed for a delta rule extender, that is, a class that computes / changes the delta (update weight) value according to some algorithm.

Author:
  Boris Jansen

Constructor Summary
`DeltaRuleExtender()` Creates a new instance of DeltaExtender

Method Summary
`abstract double` | `getDelta(double[] currentGradientOuts, int j, double aPreviousDelta)` Computes the delta value for a bias.
`abstract double` | `getDelta(double[] currentInps, int j, double[] currentPattern, int k, double aPreviousDelta)` Computes the delta value for a weight.

Methods inherited from class org.joone.engine.extenders.LearnerExtender
`getLearner, isEnabled, postBiasUpdate, postWeightUpdate, preBiasUpdate, preWeightUpdate, setEnabled, setLearner`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### DeltaRuleExtender

    public DeltaRuleExtender()

  Creates a new instance of DeltaExtender

Method Detail

### getDelta

    public abstract double getDelta(double[] currentGradientOuts,
                                    int j,
                                    double aPreviousDelta)

  Computes the delta value for a bias.

  Parameters:
    `currentGradientOuts` - the back propagated gradients.
    `j` - the index of the bias.
    `aPreviousDelta` - a delta value calculated by a previous delta extender.

### getDelta

    public abstract double getDelta(double[] currentInps,
                                    int j,
                                    double[] currentPattern,
                                    int k,
                                    double aPreviousDelta)

  Computes the delta value for a weight.

  Parameters:
    `currentInps` - the forwarded input.
    `j` - the input index of the weight.
    `currentPattern` - the back propagated gradients.
    `k` - the output index of the weight.
    `aPreviousDelta` - a delta value calculated by a previous delta extender.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit Feedback to pmarrone@users.sourceforge.net